<?php
/**
 * @package     K2 Signle Item Redirect
 * @version     1.1
 * @author      Stergios Zgouletas <info@web-expert.gr>
 * @link        http://www.web-expert.gr
 * @copyright   Copyright (C) 2010 Web-Expert.gr All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
//error_reporting(1);
//ini_set('display_errors',1);
class plgSystemK2singleitemredirect extends JPlugin
{
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}
	
	function onAfterDispatch()
	{
		$app =JFactory::getApplication();
		if($app->isAdmin() || $app->input->get('option')!='com_k2' || $app->input->get('view')!='itemlist' || $app->input->get('layout')=='category') return;		
		
		$excids=explode(',',trim($this->params->get('excids','')));
		$category=$app->input->get('id');
		list($catID,$catAlias)=explode(':',$category);
		$catID=(int)$catID;
		if($catID>0 && !in_array($catID,$excids))
		{
			$db = JFactory::getDBO();
			$numCateg=0;
			if((int)$this->params->get('subcatcheck',0))
			{
				$db->setQuery('SELECT count(id) FROM `#__k2_categories` WHERE `published`=1 AND `parent`='.$catID);
				$numCateg=(int)$db->loadResult();
			}
			
			if($numCateg==0)
			{
				$db->setQuery('SELECT `id`,`alias` FROM `#__k2_items` WHERE `published`=1 AND `catid`='.$catID.' ORDER BY `publish_up` DESC LIMIT 2;');
				$items=$db->loadObjectList();
				if(count($items)==1)
				{
					JLoader::register('K2HelperRoute',JPATH_COMPONENT.DS.'helpers'.DS.'route.php');
					$link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($items[0]->id.':'.urlencode($items[0]->alias),$catID.':'.urlencode($catAlias))));
					$app->redirect($link); 
				}
			}
		}
	}
}